import { AppVersionPresentation } from 'patchkit_api_foundation';
import { AppBranchProps } from './app-branch-props';
/**
 * Hook that retrieves app branch versions presentation, also known as changelogs.
 * @param appId App ID.
 * @param appBranchId App branch ID.
 * @returns App branch versions presentation.
 */
export declare const useAppBranchVersionsPresentation: ({ appId, appBranchId }: AppBranchProps) => [string, AppVersionPresentation][];
/**
 * Hook that revalidates app branch versions presentation.
 * @param appId App ID.
 * @param appBranchId App branch ID.
 * @returns Revalidation function.
 */
export declare const useRevalidateAppBranchVersionsPresentation: ({ appId, appBranchId, }: AppBranchProps) => () => Promise<any>;
//# sourceMappingURL=app-branch-versions-presentations.d.ts.map