import { AppBranchProps } from './app-branch-props';
/**
 * Gets the download history (install, update or repair) of apps.
 * @returns Download history of apps.
 */
export declare const getDownloadHistory: () => {
    appId: string;
    appBranchId: string;
}[];
/**
 * Marks the date when the app was last downloaded (updated, installed or repaired).
 * @param appId App ID.
 * @param appBranchId App branch ID.
 */
export declare const markAppDownloadDate: ({ appId, appBranchId }: AppBranchProps) => void;
/**
 * Gets the date when the app was last downloaded (updated, installed or repaired).
 * @param appId App ID.
 * @param appBranchId App branch ID.
 * @returns Date when the app was last downloaded (updated, installed or repaired).
 */
export declare const getAppDownloadDate: ({ appId, appBranchId }: AppBranchProps) => Date | undefined;
//# sourceMappingURL=app-download-date.d.ts.map