var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
var downloadDateKeyPrefix = 'download-date-';
var downloadDatesKeyPrefix = 'download-dates';
/**
 * Gets the download history (install, update or repair) of apps.
 * @returns Download history of apps.
 */
export var getDownloadHistory = function () {
    var key = "".concat(downloadDatesKeyPrefix);
    var value = JSON.parse(localStorage.getItem(key) || '[]');
    return value;
};
/**
 * Marks the date when the app was last downloaded (updated, installed or repaired).
 * @param appId App ID.
 * @param appBranchId App branch ID.
 */
export var markAppDownloadDate = function (_a) {
    var appId = _a.appId, appBranchId = _a.appBranchId;
    var key = "".concat(downloadDatesKeyPrefix);
    var values = getDownloadHistory();
    var appKey = "".concat(downloadDateKeyPrefix).concat(appId, "-").concat(appBranchId);
    var now = Date.now();
    localStorage.setItem(appKey, now.toString());
    var newValues = __spreadArray([{ appId: appId, appBranchId: appBranchId }], values.slice(0, 9), true);
    return localStorage.setItem(key, JSON.stringify(newValues));
};
/**
 * Gets the date when the app was last downloaded (updated, installed or repaired).
 * @param appId App ID.
 * @param appBranchId App branch ID.
 * @returns Date when the app was last downloaded (updated, installed or repaired).
 */
export var getAppDownloadDate = function (_a) {
    var appId = _a.appId, appBranchId = _a.appBranchId;
    var key = "".concat(downloadDateKeyPrefix).concat(appId, "-").concat(appBranchId);
    var value = localStorage.getItem(key);
    return value ? new Date(parseInt(value)) : undefined;
};
//# sourceMappingURL=app-download-date.js.map