import { AppBranchProps } from '../app-branch-props';
/**
 * Hook that returns app install package size.
 * @param appId App ID.
 * @param appBranchId App branch ID.
 * @returns App install package size.
 */
export declare const useAppInstallPackageSize: ({ appId, appBranchId }: AppBranchProps) => number | undefined;
/**
 * Hook that allows revalidating app install package size.
 * @param appId App ID.
 * @param appBranchId App branch ID.
 * @returns Revalidate app install package size function.
 */
export declare const useRevalidateAppInstallPackageSize: ({ appId, appBranchId }: AppBranchProps) => () => Promise<any>;
//# sourceMappingURL=app-install-package-size.d.ts.map