import { AppBranchProps } from '../app-branch-props';
/**
 * Hook that returns app update package size.
 * @param appId App ID.
 * @param appBranchId App branch ID.
 * @returns App update package size.
 */
export declare const useAppUpdatePackageSize: ({ appId, appBranchId }: AppBranchProps) => number | undefined;
/**
 * Hook that allows revalidating app update package size.
 * @param appId App ID.
 * @param appBranchId App branch ID.
 * @returns Revalidate app update package size function.
 */
export declare const useRevalidateAppUpdatePackageSize: ({ appId, appBranchId }: AppBranchProps) => () => Promise<any>;
//# sourceMappingURL=app-update-package-size.d.ts.map