import { AppBranchProps } from '../app-branch-props';
interface Props extends AppBranchProps {
    versionId?: number;
}
/**
 * Hook that returns app version presentation. Also known as changelog. If version ID is not provided, latest version presentation is returned.
 * @param appId App ID.
 * @param appBranchId App branch ID.
 * @param versionId Version ID.
 * @returns App version presentation.
 */
export declare const useAppVersion: ({ appId, appBranchId, versionId }: Props) => import("patchkit_api_foundation").AppVersionPresentation | undefined;
/**
 * Hook that allows revalidating app version presentation.
 * @param appId App ID.
 * @param appBranchId App branch ID.
 * @param versionId Version ID.
 * @returns Revalidate app version presentation function.
 */
export declare const useRevalidateAppVersion: ({ appId, appBranchId, versionId }: Props) => () => Promise<any>;
export {};
//# sourceMappingURL=app-version.d.ts.map