import { useMemo } from 'react';
import { useAppState } from '../app-state';
/**
 * Hook that returns whether app needs repair.
 * @param appId App ID.
 * @param appBranchId App branch ID.
 * @returns Whether app needs repair.
 */
export var useDoesAppNeedsRepair = function (_a) {
    var appId = _a.appId, appBranchId = _a.appBranchId;
    var appState = useAppState({ appId: appId });
    var doesAppNeedsRepair = useMemo(function () {
        var _a;
        return !!((_a = appState === null || appState === void 0 ? void 0 : appState.branches[appBranchId]) === null || _a === void 0 ? void 0 : _a.doesNeedRepair);
    }, [appState, appBranchId]);
    return doesAppNeedsRepair;
};
//# sourceMappingURL=does-app-need-repair.js.map