import { AppBranchProps } from '../app-branch-props';
/**
 * Hook that returns whether app has new version available.
 * @param appId App ID.
 * @param appBranchId App branch ID.
 * @returns Whether app has new version available.
 */
export declare const useIsAppNewVersionAvailable: ({ appId, appBranchId }: AppBranchProps) => boolean;
/**
 * Hook that returns revalidate function for isAppNewVersionAvailable hook. It can be used to implement check for updates button.
 * @param appId App ID.
 * @param appBranchId App branch ID.
 * @returns Revalidate function.
 */
export declare const useRevalidateIsAppNewVersionAvailable: ({ appId, appBranchId }: AppBranchProps) => () => Promise<any>;
//# sourceMappingURL=is-app-new-version-available.d.ts.map