import { useMemo } from 'react';
import { useAppState } from '../app-state';
/**
 * Hook that returns whether app is started.
 * @param appId App ID.
 * @param appBranchId App branch ID.
 * @returns Whether app is started.
 */
export var useIsAppStarted = function (_a) {
    var appId = _a.appId, appBranchId = _a.appBranchId;
    var appState = useAppState({ appId: appId });
    var isAppStarted = useMemo(function () {
        if (appState === undefined) {
            return false;
        }
        var branch = appState.branches[appBranchId];
        if (branch === undefined) {
            return false;
        }
        return branch.process !== undefined;
    }, [appState, appBranchId]);
    return isAppStarted;
};
//# sourceMappingURL=is-app-started.js.map