import { AppBranchProps } from '../app-branch-props';
/**
 * Hook that returns latest version ID for app branch.
 * @param appId App ID.
 * @param appBranchId App branch ID.
 * @returns Latest version ID.
 */
export declare const useLatestVersionId: ({ appId, appBranchId }: AppBranchProps) => number | undefined;
/**
 * Hook that allows revalidating latest version ID for app branch. This is useful when you want to implement check for updates button.
 * @param appId App ID.
 * @param appBranchId App branch ID.
 * @returns Revalidate latest version ID function.
 */
export declare const useRevalidateLatestVersionId: ({ appId, appBranchId }: AppBranchProps) => () => Promise<any>;
//# sourceMappingURL=latest-version-id.d.ts.map