var installDateKeyPrefix = 'install-date-';
/**
 * Marks the date when the app was last installed.
 * @param appId App ID.
 * @param appBranchId App branch ID.
 */
export var markAppInstallDate = function (_a) {
    var appId = _a.appId, appBranchId = _a.appBranchId;
    var key = "".concat(installDateKeyPrefix).concat(appId, "-").concat(appBranchId);
    var now = Date.now();
    return localStorage.setItem(key, now.toString());
};
/**
 * Gets the date when the app was last installed.
 * @param appId App ID.
 * @param appBranchId App branch ID.
 * @returns Date when the app was last installed.
 */
export var getAppInstallDate = function (_a) {
    var appId = _a.appId, appBranchId = _a.appBranchId;
    var key = "".concat(installDateKeyPrefix).concat(appId, "-").concat(appBranchId);
    var value = localStorage.getItem(key);
    return value ? new Date(parseInt(value)) : undefined;
};
//# sourceMappingURL=app-installed-date.js.map