var playDateKeyPrefix = 'play-date-';
/**
 * Marks the date when the app was last played.
 * @param appId App ID.
 * @param appBranchId App branch ID.
 */
export var markAppPlayDate = function (_a) {
    var appId = _a.appId, appBranchId = _a.appBranchId;
    var key = "".concat(playDateKeyPrefix).concat(appId, "-").concat(appBranchId);
    var now = Date.now();
    return localStorage.setItem(key, now.toString());
};
/**
 * Gets the date when the app was last played.
 * @param appId App ID.
 * @param appBranchId App branch ID.
 * @returns Date when the app was last played.
 */
export var getAppPlayDate = function (_a) {
    var appId = _a.appId, appBranchId = _a.appBranchId;
    var key = "".concat(playDateKeyPrefix).concat(appId, "-").concat(appBranchId);
    var value = localStorage.getItem(key);
    return value ? new Date(parseInt(value)) : undefined;
};
//# sourceMappingURL=app-played-date.js.map