import { retrieveAppPresentationAsync } from 'patchkit-generic-patcher2_ipc';
import useSWR from 'swr';
import { useRevalidate } from './revalidate';
/**
 * Hook that retrieves app presentation, including articles, urls, media, etc.
 * @param appId App ID.
 * @returns App presentation.
 */
export var useAppPresentation = function (_a) {
    var appId = _a.appId;
    var url = "app-presentation/".concat(appId);
    var data = useSWR(url, function () { return retrieveAppPresentationAsync({ appId: appId }); }).data;
    return data;
};
/**
 * Hook that revalidates app presentation.
 * @param appId App ID.
 * @returns Revalidation function.
 */
export var useRevalidateAppPresentation = function (_a) {
    var appId = _a.appId;
    var url = "app-presentation/".concat(appId);
    var revalidate = useRevalidate();
    return function () { return revalidate(url); };
};
//# sourceMappingURL=app-presentation.js.map