import { useContext, useMemo } from 'react';
import { LauncherStateContext } from './launcher-state';
/**
 * Hook for getting app state.
 * @param appId App ID.
 * @returns App state.
 */
export var useAppState = function (_a) {
    var appId = _a.appId;
    var currentLauncherState = useContext(LauncherStateContext).currentLauncherState;
    var apps = useMemo(function () {
        return currentLauncherState === null || currentLauncherState === void 0 ? void 0 : currentLauncherState.apps;
    }, [currentLauncherState]);
    var appState = useMemo(function () {
        return apps === null || apps === void 0 ? void 0 : apps[appId];
    }, [apps, appId]);
    return appState;
};
//# sourceMappingURL=app-state.js.map