import { useContext } from 'react';
import { DownloadQueueContext, QueueTaskType } from './queue-context';
/**
 * Hook that adds install task to the queue.
 * @param appId App ID.
 * @param appBranchId App branch ID.
 * @param path Path to install to.
 * @returns Add install task to queue function.
 */
export var useAddInstallToQueue = function (_a) {
    var appBranchId = _a.appBranchId, appId = _a.appId, path = _a.path;
    var addTaskToQueue = useContext(DownloadQueueContext).addTaskToQueue;
    return function () {
        return addTaskToQueue({
            appBranchId: appBranchId,
            appId: appId,
            path: path,
            type: QueueTaskType.Install,
        });
    };
};
//# sourceMappingURL=add-install-to-queue.js.map