import { useContext } from 'react';
import { DownloadQueueContext, QueueTaskType } from './queue-context';
/**
 * Hook that adds repair task to the queue.
 * @param appId App ID.
 * @param appBranchId App branch ID.
 * @returns Add repair task to queue function.
 */
export var useAddRepairToQueue = function (_a) {
    var appBranchId = _a.appBranchId, appId = _a.appId;
    var addTaskToQueue = useContext(DownloadQueueContext).addTaskToQueue;
    return function () {
        return addTaskToQueue({
            appBranchId: appBranchId,
            appId: appId,
            type: QueueTaskType.Repair,
        });
    };
};
//# sourceMappingURL=add-repair-to-queue.js.map