import { useContext } from 'react';
import { DownloadQueueContext, QueueTaskType } from './queue-context';
/**
 * Hook that adds update task to the queue.
 * @param appId App ID.
 * @param appBranchId App branch ID.
 * @returns Add update task to queue function.
 */
export var useAddUpdateToQueue = function (_a) {
    var appBranchId = _a.appBranchId, appId = _a.appId;
    var addTaskToQueue = useContext(DownloadQueueContext).addTaskToQueue;
    return function () {
        return addTaskToQueue({
            appBranchId: appBranchId,
            appId: appId,
            type: QueueTaskType.Update,
        });
    };
};
//# sourceMappingURL=add-update-to-queue.js.map