import { useContext } from 'react';
import { DownloadQueueContext, QueueTaskType } from './queue-context';
/**
 * Hook that checks if there is an repair task for app in the queue.
 * @param appId App ID.
 * @param appBranchId App branch ID.
 * @returns True if repair task is in queue.
 */
export var useIsRepairInQueue = function (_a) {
    var appId = _a.appId, appBranchId = _a.appBranchId;
    var queue = useContext(DownloadQueueContext).queue;
    return (queue.find(function (task) {
        return task.appId === appId &&
            task.appBranchId === appBranchId &&
            task.type === QueueTaskType.Repair;
    }) !== undefined);
};
//# sourceMappingURL=is-repair-in-queue.js.map