import { useContext } from 'react';
import { DownloadQueueContext, QueueTaskType } from './queue-context';
/**
 * Hook that checks if there is an update task for app in the queue.
 * @param appId App ID.
 * @param appBranchId App branch ID.
 * @returns True if update task is in queue.
 */
export var useIsUpdateInQueue = function (_a) {
    var appId = _a.appId, appBranchId = _a.appBranchId;
    var queue = useContext(DownloadQueueContext).queue;
    return (queue.find(function (task) {
        return task.appId === appId &&
            task.appBranchId === appBranchId &&
            task.type === QueueTaskType.Update;
    }) !== undefined);
};
//# sourceMappingURL=is-update-in-queue.js.map