/// <reference types="react" />
import { AppBranchProps } from '../app-branch-props';
export interface DownloadQueueContextType {
    /**
     * Queue of tasks that are going to be executed.
     */
    queue: Array<DownloadQueueItem>;
    /**
     * Function that allows to add task to the queue.
     * @param item Task that is going to be added to the queue.
     */
    addTaskToQueue: (item: DownloadQueueItem) => void;
    /**
     * Is there any active task.
     */
    hasActiveTask: boolean;
    /**
     * Function that allows to resume current task.
     */
    resumeCurrentTask: () => void;
}
export declare enum QueueTaskType {
    Install = 0,
    Update = 1,
    Repair = 2
}
export interface DownloadQueueItem extends AppBranchProps {
    path?: string;
    type: QueueTaskType;
}
/**
 * Context that allows to manage download queue. It takes tasks and executes them one by one in FIFO order.
 */
export declare const DownloadQueueContext: import("react").Context<DownloadQueueContextType>;
export declare const DownloadQueueContextProvider: ({ children }: React.PropsWithChildren) => JSX.Element;
//# sourceMappingURL=queue-context.d.ts.map