var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
import { jsx as _jsx } from "react/jsx-runtime";
import { createContext, useCallback, useContext, useEffect, useMemo, useState } from 'react';
import { AppBranchInstallTaskError, AppBranchRepairTaskError, AppBranchUpdateTaskError, } from 'patchkit-generic-patcher2_foundation';
import { useApps } from '../apps';
import { LauncherStateContext } from '../launcher-state';
import { defaultInstallApp } from '../tasks/install-app';
import { defaultRepairApp } from '../tasks/repair-app';
import { defaultUpdateApp } from '../tasks/update-app';
export var QueueTaskType;
(function (QueueTaskType) {
    QueueTaskType[QueueTaskType["Install"] = 0] = "Install";
    QueueTaskType[QueueTaskType["Update"] = 1] = "Update";
    QueueTaskType[QueueTaskType["Repair"] = 2] = "Repair";
})(QueueTaskType || (QueueTaskType = {}));
var queueStorageKey = 'download-queue';
var saveQueueToLocalStorage = function (queue) {
    localStorage.setItem(queueStorageKey, JSON.stringify(queue));
};
var getQueueFromLocalStorage = function () {
    var queue = localStorage.getItem(queueStorageKey);
    if (queue) {
        return JSON.parse(queue);
    }
    return [];
};
var currentTaskStorageKey = 'current-task';
var saveCurrentTaskToLocalStorage = function (task) {
    localStorage.setItem(currentTaskStorageKey, JSON.stringify(task));
};
var getLastCurrentTaskFromLocalStorage = function () {
    var task = localStorage.getItem(currentTaskStorageKey);
    if (task) {
        return JSON.parse(task);
    }
    return undefined;
};
var removeCurrentTaskFromLocalStorage = function () {
    localStorage.removeItem(currentTaskStorageKey);
};
/**
 * Context that allows to manage download queue. It takes tasks and executes them one by one in FIFO order.
 */
export var DownloadQueueContext = createContext({
    queue: [],
    addTaskToQueue: function () { return ({}); },
    hasActiveTask: false,
    resumeCurrentTask: function () { return ({}); },
});
export var DownloadQueueContextProvider = function (_a) {
    var children = _a.children;
    var apps = useApps();
    var _b = useState(getLastCurrentTaskFromLocalStorage()), currentTask = _b[0], setCurrentTask = _b[1];
    var _c = useState(getQueueFromLocalStorage()), queue = _c[0], setQueue = _c[1];
    var updateOngoingTask = useContext(LauncherStateContext).updateOngoingTask;
    var currentAppBranchState = useMemo(function () {
        var _a;
        if (!currentTask) {
            return undefined;
        }
        return (_a = apps.get(currentTask.appId)) === null || _a === void 0 ? void 0 : _a.branches[currentTask.appBranchId];
    }, [currentTask, apps]);
    var isCurrentTaskRunning = useMemo(function () {
        return ((currentAppBranchState === null || currentAppBranchState === void 0 ? void 0 : currentAppBranchState.ongoingInstallTaskId) !== undefined ||
            (currentAppBranchState === null || currentAppBranchState === void 0 ? void 0 : currentAppBranchState.ongoingUpdateTaskId) !== undefined ||
            (currentAppBranchState === null || currentAppBranchState === void 0 ? void 0 : currentAppBranchState.ongoingRepairTaskId) !== undefined);
    }, [currentAppBranchState]);
    var isCurrentTaskCancelled = useMemo(function () {
        var _a, _b, _c, _d, _e, _f;
        if (isCurrentTaskRunning) {
            return false;
        }
        switch (currentTask === null || currentTask === void 0 ? void 0 : currentTask.type) {
            case QueueTaskType.Install:
                return (((_b = (_a = currentAppBranchState === null || currentAppBranchState === void 0 ? void 0 : currentAppBranchState.lastFilesOperationTask) === null || _a === void 0 ? void 0 : _a.appBranchLastInstallTaskState) === null || _b === void 0 ? void 0 : _b.error) ===
                    AppBranchInstallTaskError.Cancelled);
            case QueueTaskType.Update:
                return (((_d = (_c = currentAppBranchState === null || currentAppBranchState === void 0 ? void 0 : currentAppBranchState.lastFilesOperationTask) === null || _c === void 0 ? void 0 : _c.appBranchLastUpdateTaskState) === null || _d === void 0 ? void 0 : _d.error) ===
                    AppBranchUpdateTaskError.Cancelled);
            case QueueTaskType.Repair:
                return (((_f = (_e = currentAppBranchState === null || currentAppBranchState === void 0 ? void 0 : currentAppBranchState.lastFilesOperationTask) === null || _e === void 0 ? void 0 : _e.appBranchLastRepairTaskState) === null || _f === void 0 ? void 0 : _f.error) ===
                    AppBranchRepairTaskError.Cancelled);
        }
    }, [currentAppBranchState, isCurrentTaskRunning, currentTask]);
    var isInitialized = useMemo(function () {
        if (currentTask !== undefined && currentAppBranchState === undefined) {
            return false;
        }
        return true;
    }, [currentTask, currentAppBranchState]);
    var executeTask = useCallback(function (newTask) { return __awaiter(void 0, void 0, void 0, function () {
        var appState, _a, _b;
        return __generator(this, function (_c) {
            switch (_c.label) {
                case 0:
                    setCurrentTask(newTask);
                    appState = apps.get(newTask.appId);
                    if (!appState) return [3 /*break*/, 11];
                    _c.label = 1;
                case 1:
                    _c.trys.push([1, 9, , 10]);
                    _a = newTask.type;
                    switch (_a) {
                        case QueueTaskType.Install: return [3 /*break*/, 2];
                        case QueueTaskType.Update: return [3 /*break*/, 4];
                        case QueueTaskType.Repair: return [3 /*break*/, 6];
                    }
                    return [3 /*break*/, 8];
                case 2: return [4 /*yield*/, updateOngoingTask({
                        appId: newTask.appId,
                        appBranchId: newTask.appBranchId,
                        task: 'install',
                    }, function () {
                        return defaultInstallApp({
                            appId: newTask.appId,
                            appBranchId: newTask.appBranchId,
                            path: newTask.path,
                            appState: appState,
                        });
                    })];
                case 3: return [2 /*return*/, _c.sent()];
                case 4: return [4 /*yield*/, updateOngoingTask({
                        appId: newTask.appId,
                        appBranchId: newTask.appBranchId,
                        task: 'update',
                    }, function () {
                        return defaultUpdateApp({
                            appId: newTask.appId,
                            appBranchId: newTask.appBranchId,
                            appState: appState,
                        });
                    })];
                case 5: return [2 /*return*/, _c.sent()];
                case 6: return [4 /*yield*/, updateOngoingTask({
                        appId: newTask.appId,
                        appBranchId: newTask.appBranchId,
                        task: 'repair',
                    }, function () {
                        return defaultRepairApp({
                            appId: newTask.appId,
                            appBranchId: newTask.appBranchId,
                            appState: appState,
                        });
                    })];
                case 7: return [2 /*return*/, _c.sent()];
                case 8: return [3 /*break*/, 10];
                case 9:
                    _b = _c.sent();
                    setCurrentTask(undefined);
                    return [3 /*break*/, 10];
                case 10: return [3 /*break*/, 11];
                case 11: return [2 /*return*/];
            }
        });
    }); }, [apps, updateOngoingTask]);
    var resumeCurrentTask = useCallback(function () { return __awaiter(void 0, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    if (!currentTask) {
                        return [2 /*return*/];
                    }
                    if (!isCurrentTaskCancelled) {
                        return [2 /*return*/];
                    }
                    return [4 /*yield*/, executeTask(currentTask)];
                case 1:
                    _a.sent();
                    return [2 /*return*/];
            }
        });
    }); }, [currentTask, executeTask, isCurrentTaskCancelled]);
    var takeNewTask = useCallback(function () { return __awaiter(void 0, void 0, void 0, function () {
        var newTask;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    newTask = queue[0];
                    setQueue(function (q) { return q.slice(1); });
                    return [4 /*yield*/, executeTask(newTask)];
                case 1:
                    _a.sent();
                    return [2 /*return*/];
            }
        });
    }); }, [queue, executeTask]);
    useEffect(function () {
        // no task so lets take new one from queue
        if (!isCurrentTaskCancelled && !isCurrentTaskRunning && queue.length > 0 && isInitialized) {
            takeNewTask();
        }
    }, [takeNewTask, isCurrentTaskCancelled, isCurrentTaskRunning, queue, isInitialized]);
    var addTaskToQueue = useCallback(function (task) {
        if (queue.length === 0) {
            executeTask(task);
        }
        else {
            setQueue(function (q) { return __spreadArray(__spreadArray([], q, true), [task], false); });
        }
    }, [executeTask, queue.length]);
    useEffect(function () {
        saveQueueToLocalStorage(queue);
    }, [queue]);
    useEffect(function () {
        if (currentTask) {
            saveCurrentTaskToLocalStorage(currentTask);
        }
        else {
            removeCurrentTaskFromLocalStorage();
        }
    }, [currentTask]);
    return (_jsx(DownloadQueueContext.Provider, __assign({ value: {
            queue: queue,
            addTaskToQueue: addTaskToQueue,
            hasActiveTask: currentTask !== undefined,
            resumeCurrentTask: resumeCurrentTask,
        } }, { children: children })));
};
//# sourceMappingURL=queue-context.js.map