var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
import { DefaultYesOrNoDialogResult } from 'patchkit-generic-patcher2_foundation';
import { showDefaultErrorDialogAsync, showDefaultYesOrNoDialogAsync, tryRestartingWithElevatedPermissionsAsync, } from 'patchkit-generic-patcher2_ipc';
/**
 * Function that handles general unauthorized access to the app directory.
 * @param appState App state.
 */
export var handleUnauthorizedAccessToAppDirAsync = function (_a) {
    var appState = _a.appState;
    return __awaiter(void 0, void 0, void 0, function () {
        var defaultYesOrNoDialogResult, _b;
        return __generator(this, function (_c) {
            switch (_c.label) {
                case 0: return [4 /*yield*/, showDefaultErrorDialogAsync({
                        defaultErrorDialogTitle: 'Error!',
                        defaultErrorDialogMessage: "Unauthorized access to ".concat(appState.name, " folder."),
                    })];
                case 1:
                    _c.sent();
                    return [4 /*yield*/, showDefaultYesOrNoDialogAsync({
                            defaultYesOrNoDialogTitle: 'Unauthorized access',
                            defaultYesOrNoDialogMessage: "Cannot access the ".concat(appState.name, " folder. Would you like to restart the patcher with higher permissions?"),
                        })];
                case 2:
                    defaultYesOrNoDialogResult = _c.sent();
                    _b = defaultYesOrNoDialogResult;
                    switch (_b) {
                        case DefaultYesOrNoDialogResult.Yes: return [3 /*break*/, 3];
                        case DefaultYesOrNoDialogResult.No: return [3 /*break*/, 7];
                    }
                    return [3 /*break*/, 8];
                case 3: return [4 /*yield*/, tryRestartingWithElevatedPermissionsAsync({})];
                case 4:
                    if (!!(_c.sent())) return [3 /*break*/, 6];
                    return [4 /*yield*/, showDefaultErrorDialogAsync({
                            defaultErrorDialogTitle: 'Error!',
                            defaultErrorDialogMessage: 'Cannot restart the patcher with higher permissions.',
                        })];
                case 5:
                    _c.sent();
                    _c.label = 6;
                case 6: return [3 /*break*/, 8];
                case 7:
                    {
                        return [3 /*break*/, 8];
                    }
                    _c.label = 8;
                case 8: return [2 /*return*/];
            }
        });
    });
};
//# sourceMappingURL=handle-unauthorized-access-to-app-dir-async.js.map