import { useMemo } from 'react';
import { useAppState } from '../app-state';
/**
 * Hook that returns last install task state that has ended with error (Cancelling task is an error).
 * @param appId App ID.
 * @param appBranchId App branch ID.
 * @returns Last install task state that has ended with error.
 */
export var useLastInstallTaskState = function (_a) {
    var appId = _a.appId, appBranchId = _a.appBranchId;
    var appState = useAppState({ appId: appId });
    var lastInstallTaskState = useMemo(function () {
        var _a, _b;
        return (_b = (_a = appState === null || appState === void 0 ? void 0 : appState.branches[appBranchId]) === null || _a === void 0 ? void 0 : _a.lastFilesOperationTask) === null || _b === void 0 ? void 0 : _b.appBranchLastInstallTaskState;
    }, [appState, appBranchId]);
    return lastInstallTaskState;
};
//# sourceMappingURL=last-install-task-state.js.map