var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
import { jsx as _jsx } from "react/jsx-runtime";
import { createContext, useCallback, useRef } from 'react';
import equal from 'fast-deep-equal';
import { fetchStateAsync } from 'patchkit-generic-patcher2_ipc';
import useSWR from 'swr';
var LAUNCHER_STATE_URL = 'launcher-state';
/**
 * Hook that allows to get current state of the launcher.
 * @returns Current state of the launcher.
 * @returns Function that allows to mutate state of the launcher.
 */
export var useLauncherState = function () {
    var _a = useSWR(LAUNCHER_STATE_URL, function () { return fetchStateAsync({}); }, {
        refreshInterval: 100,
    }), data = _a.data, error = _a.error, mutate = _a.mutate;
    if (error) {
        console.log(error);
    }
    return { data: data, mutate: mutate };
};
/**
 * Heart of the launcher. It contains state of tasks, apps and window.
 */
export var LauncherStateContext = createContext({
    currentLauncherState: undefined,
    updateOngoingTask: function () { return Promise.resolve(); },
    updateWindowIsMaximized: function () { return Promise.resolve(); },
});
export var LauncherStateContextProvider = function (_a) {
    var children = _a.children;
    var previousState = useRef();
    var _b = useLauncherState(), currentLauncherState = _b.data, mutate = _b.mutate;
    var updateOngoingTask = useCallback(function (_a, updateFn) {
        var appBranchId = _a.appBranchId, appId = _a.appId, task = _a.task;
        return __awaiter(void 0, void 0, void 0, function () {
            var app, branch, newState_1;
            var _b, _c;
            return __generator(this, function (_d) {
                switch (_d.label) {
                    case 0:
                        app = currentLauncherState === null || currentLauncherState === void 0 ? void 0 : currentLauncherState.apps[appId];
                        branch = app === null || app === void 0 ? void 0 : app.branches[appBranchId];
                        if (!(currentLauncherState !== undefined && app !== undefined && branch !== undefined)) return [3 /*break*/, 2];
                        newState_1 = __assign(__assign({}, currentLauncherState), { apps: __assign(__assign({}, currentLauncherState.apps), (_b = {}, _b[appId] = __assign(__assign({}, app), { branches: __assign(__assign({}, app.branches), (_c = {}, _c[appBranchId] = __assign(__assign({}, branch), { ongoingInstallTaskId: task === 'install' ? 0 : undefined, ongoingUninstallTaskId: task === 'uninstall' ? 0 : undefined, ongoingRepairTaskId: task === 'repair' ? 0 : undefined, ongoingUpdateTaskId: task === 'update' ? 0 : undefined, ongoingMoveTaskId: task === 'move' ? 0 : undefined }), _c)) }), _b)) });
                        return [4 /*yield*/, mutate(function () { return updateFn().then(function () { return newState_1; }); }, {
                                optimisticData: newState_1,
                                rollbackOnError: true,
                            })];
                    case 1:
                        _d.sent();
                        _d.label = 2;
                    case 2: return [2 /*return*/];
                }
            });
        });
    }, [currentLauncherState, mutate]);
    var updateWindowIsMaximized = useCallback(function (isMaximized, updateFn) { return __awaiter(void 0, void 0, void 0, function () {
        var newState_2;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    if (!(currentLauncherState !== undefined)) return [3 /*break*/, 2];
                    newState_2 = __assign(__assign({}, currentLauncherState), { windowIsMaximized: isMaximized });
                    return [4 /*yield*/, mutate(function () { return updateFn().then(function () { return newState_2; }); }, {
                            optimisticData: newState_2,
                        })];
                case 1:
                    _a.sent();
                    _a.label = 2;
                case 2: return [2 /*return*/];
            }
        });
    }); }, [currentLauncherState, mutate]);
    if (!equal(previousState.current, currentLauncherState)) {
        previousState.current = currentLauncherState;
        return (_jsx(LauncherStateContext.Provider, __assign({ value: { currentLauncherState: currentLauncherState, updateOngoingTask: updateOngoingTask, updateWindowIsMaximized: updateWindowIsMaximized } }, { children: children })));
    }
    return (_jsx(LauncherStateContext.Provider, __assign({ value: {
            currentLauncherState: previousState.current,
            updateOngoingTask: updateOngoingTask,
            updateWindowIsMaximized: updateWindowIsMaximized,
        } }, { children: children })));
};
//# sourceMappingURL=launcher-state.js.map