import { AppState } from 'patchkit-generic-patcher2_foundation';
import { AppBranchProps } from '../app-branch-props';
export declare class NotEnoughRepairSpaceError extends Error {
    constructor();
}
interface RepairAppProps extends AppBranchProps {
    appBranchAuthKey?: string;
    appState: AppState;
}
/**
 * Default repair app function. It checks available space and starts repair task. It also marks app download date.
 * @param appId App ID.
 * @param appBranchId App branch ID.
 * @param appBranchAuthKey App branch auth key.
 * @param appState App state.
 */
export declare const defaultRepairApp: ({ appId, appBranchId, appBranchAuthKey, appState, }: RepairAppProps) => Promise<void>;
/**
 * Hook for repairing app. It updates launcher state with optimistic information about repair start and starts repair task.
 * @param appBranchId App branch ID.
 * @param appId App ID.
 * @returns Repair app function.
 */
export declare const useRepairApp: ({ appBranchId, appId }: AppBranchProps) => () => Promise<void>;
export {};
//# sourceMappingURL=repair-app.d.ts.map