import { AppState } from 'patchkit-generic-patcher2_foundation';
import { AppBranchProps } from '../app-branch-props';
export declare class NotEnoughUpdateSpaceError extends Error {
    constructor();
}
interface UpdateAppProps extends AppBranchProps {
    appBranchAuthKey?: string;
    appState: AppState;
}
/**
 * Default update app function. It checks available space and starts update task. It also marks app download date.
 * @param appId App ID.
 * @param appBranchId App branch ID.
 * @param appBranchAuthKey App branch auth key.
 * @param appState App state.
 */
export declare const defaultUpdateApp: ({ appId, appBranchId, appBranchAuthKey, appState, }: UpdateAppProps) => Promise<void>;
/**
 * Hook for updating app. It updates launcher state with optimistic information about update start and uses default update app function.
 * @param appBranchId App branch ID.
 * @param appId App ID.
 * @returns Update app function.
 */
export declare const useUpdateApp: ({ appBranchId, appId }: AppBranchProps) => () => Promise<void>;
export {};
//# sourceMappingURL=update-app.d.ts.map