var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
import { useCallback, useContext } from 'react';
import { UnauthorizedAccessToAppBranchDir } from 'patchkit-generic-patcher2_foundation';
import { fetchDoesAppBranchDirHasFreeSpaceForUpdateTaskAsync, showDefaultErrorDialogAsync, startAppBranchUpdateTaskAsync, } from 'patchkit-generic-patcher2_ipc';
import { markAppDownloadDate } from '../app-download-date';
import { useAppState } from '../app-state';
import { handleUnauthorizedAccessToAppDirAsync } from '../handle-unauthorized-access-to-app-dir-async';
import { LauncherStateContext } from '../launcher-state';
var NotEnoughUpdateSpaceError = /** @class */ (function (_super) {
    __extends(NotEnoughUpdateSpaceError, _super);
    function NotEnoughUpdateSpaceError() {
        return _super.call(this, 'Not enough space to update the app.') || this;
    }
    return NotEnoughUpdateSpaceError;
}(Error));
export { NotEnoughUpdateSpaceError };
/**
 * Default update app function. It checks available space and starts update task. It also marks app download date.
 * @param appId App ID.
 * @param appBranchId App branch ID.
 * @param appBranchAuthKey App branch auth key.
 * @param appState App state.
 */
export var defaultUpdateApp = function (_a) {
    var appId = _a.appId, appBranchId = _a.appBranchId, appBranchAuthKey = _a.appBranchAuthKey, appState = _a.appState;
    return __awaiter(void 0, void 0, void 0, function () {
        var doesHaveEnoughSpace, e_1;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    _b.trys.push([0, 3, 10, 11]);
                    return [4 /*yield*/, fetchDoesAppBranchDirHasFreeSpaceForUpdateTaskAsync({
                            appId: appId,
                            appBranchId: appBranchId,
                        })];
                case 1:
                    doesHaveEnoughSpace = _b.sent();
                    if (!doesHaveEnoughSpace) {
                        throw new NotEnoughUpdateSpaceError();
                    }
                    return [4 /*yield*/, startAppBranchUpdateTaskAsync({ appId: appId, appBranchId: appBranchId, appBranchAuthKey: appBranchAuthKey })];
                case 2:
                    _b.sent();
                    return [3 /*break*/, 11];
                case 3:
                    e_1 = _b.sent();
                    if (!(e_1 instanceof NotEnoughUpdateSpaceError)) return [3 /*break*/, 5];
                    return [4 /*yield*/, showDefaultErrorDialogAsync({
                            defaultErrorDialogTitle: 'Error!',
                            defaultErrorDialogMessage: 'Not enough space to update the app.',
                        })];
                case 4:
                    _b.sent();
                    throw e_1;
                case 5:
                    if (!(e_1 instanceof UnauthorizedAccessToAppBranchDir)) return [3 /*break*/, 7];
                    return [4 /*yield*/, handleUnauthorizedAccessToAppDirAsync({ appState: appState })];
                case 6:
                    _b.sent();
                    return [3 /*break*/, 9];
                case 7: return [4 /*yield*/, showDefaultErrorDialogAsync({
                        defaultErrorDialogTitle: 'Error!',
                        defaultErrorDialogMessage: 'Cannot update the app right now. Please try again later.',
                    })];
                case 8:
                    _b.sent();
                    throw e_1;
                case 9: return [3 /*break*/, 11];
                case 10:
                    markAppDownloadDate({ appId: appId, appBranchId: appBranchId });
                    return [7 /*endfinally*/];
                case 11: return [2 /*return*/];
            }
        });
    });
};
/**
 * Hook for updating app. It updates launcher state with optimistic information about update start and uses default update app function.
 * @param appBranchId App branch ID.
 * @param appId App ID.
 * @returns Update app function.
 */
export var useUpdateApp = function (_a) {
    var appBranchId = _a.appBranchId, appId = _a.appId;
    var appState = useAppState({ appId: appId });
    var updateOngoingTask = useContext(LauncherStateContext).updateOngoingTask;
    var updateApp = useCallback(function () { return __awaiter(void 0, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    if (appState === undefined) {
                        return [2 /*return*/];
                    }
                    return [4 /*yield*/, updateOngoingTask({ appId: appId, appBranchId: appBranchId, task: 'update' }, function () {
                            return defaultUpdateApp({ appId: appId, appBranchId: appBranchId, appState: appState });
                        })];
                case 1:
                    _a.sent();
                    return [2 /*return*/];
            }
        });
    }); }, [appState, appId, appBranchId, updateOngoingTask]);
    return updateApp;
};
//# sourceMappingURL=update-app.js.map