import { ComponentStory } from '@storybook/react';
import styled from 'styled-components';

import { AppGallery } from './app-gallery';

export default {
  title: 'AppGallery',
  component: AppGallery,
};

const Div = styled.div`
  width: 720px;
  overflow: hidden;
`;

const Template: ComponentStory<typeof AppGallery> = (args) => (
  <Div>
    <AppGallery {...args} />
  </Div>
);

export const WithVideos = Template.bind({});
WithVideos.args = {
  videos: [
    [
      '1',
      {
        videoUrl: 'https://www.youtube.com/watch?v=9bZkp7q19f0',
        order: 0,
      },
    ],
    [
      '1',
      {
        videoUrl: 'https://www.youtube.com/watch?v=9bZkp7q19f0',
        order: 0,
      },
    ],
  ],
  images: [
    [
      '1',
      {
        screenshotUrl: 'https://dummyimage.com/600x400/000/fff',
        order: 0,
      },
    ],
    [
      '1',
      {
        screenshotUrl: 'https://dummyimage.com/600x400/000/fff',
        order: 0,
      },
    ],
    [
      '1',
      {
        screenshotUrl: 'https://dummyimage.com/600x400/000/fff',
        order: 0,
      },
    ],
  ],
  articles: [
    [
      '1',
      {
        bannerUrl: 'https://dummyimage.com/600x400/000/fff',
        title: 'Article title',
        body: { textBody: 'body' },
        createdDate: new Date(),
        updatedDate: new Date(),
      },
    ],
    [
      '1',
      {
        bannerUrl: 'https://dummyimage.com/600x400/000/fff',
        title: 'Article title',
        body: { textBody: 'body' },
        createdDate: new Date(),
        updatedDate: new Date(),
      },
    ],
  ],
};
