import { ComponentStory } from '@storybook/react';

import { Card } from './card';

export default {
  title: 'Common/Card',
  component: Card,
};

const Template: ComponentStory<typeof Card> = (args) => <Card {...args} />;
export const Example = Template.bind({});
Example.args = {
  title: 'Dota',
  imageUrl:
    'https://external-content.duckduckgo.com/iu/?u=https%3A%2F%2Fwww.justpushstart.com%2Fwp-content%2Fuploads%2F2014%2F01%2FFree-Dota-2-Wallpaper.jpg&f=1&nofb=1',
  onClick: () => {
    return;
  },
};

export const WithDropdown = Template.bind({});
WithDropdown.args = {
  title: 'Dota',
  imageUrl:
    'https://external-content.duckduckgo.com/iu/?u=https%3A%2F%2Fwww.justpushstart.com%2Fwp-content%2Fuploads%2F2014%2F01%2FFree-Dota-2-Wallpaper.jpg&f=1&nofb=1',
  onClick: () => {
    return;
  },
  dropdownElements: [
    <p key="items1">item 1</p>,
    <p key="items2">item 2</p>,
    <p key="items3">item 3</p>,
  ],
};
