import { COLORS } from 'constant';
import styled from 'styled-components';

interface StyleProps {
  isOpen?: boolean;
  toTop?: boolean;
}

export const Dropdown = styled.div<StyleProps>`
  display: ${(props) => (props.isOpen ? 'block' : 'none')};
  background-color: ${COLORS.DARK_GRAY};
  color: ${COLORS.WHITE};
  border-radius: 0.25rem;
  position: absolute;
  width: 100%;
  right: 0;
  ${(props) => !props.toTop && 'top: 100%;'};
  ${(props) => props.toTop && 'bottom: 20%;'};
`;
