import { ComponentStory } from '@storybook/react';

import { LayoutStack } from './layout-stack';

export default {
  title: 'Common/Layout Stack',
  component: LayoutStack,
};

const HalfWidthTemplate: ComponentStory<typeof LayoutStack> = (args) => (
  <LayoutStack {...args}>
    <div style={styles} />
    <div style={styles} />
  </LayoutStack>
);

const WrappedTemplate: ComponentStory<typeof LayoutStack> = (args) => (
  <LayoutStack {...args}>
    <div style={styles} />
    <div style={styles} />
    <div style={styles} />
    <div style={styles} />
    <div style={styles} />
    <div style={styles} />
    <div style={styles} />
    <div style={styles} />
  </LayoutStack>
);

const styles: React.CSSProperties = { backgroundColor: 'royalblue', height: '4rem' };

export const HalfWidthStack = HalfWidthTemplate.bind({});
HalfWidthStack.args = {
  rowElements: 4,
  gapX: 0.125,
};

export const MultiRow = WrappedTemplate.bind({});
MultiRow.args = {
  rowElements: 2,
  gapX: 1,
  gapY: 1,
};
