import { ComponentStory } from '@storybook/react';

import { LaunchAppButton } from 'components/launch-app-button';

import { Popup } from './popup';

export default {
  title: 'Common/Popup',
  component: Popup,
};

const Template: ComponentStory<typeof Popup> = (args) => <Popup {...args} />;

export const Default = Template.bind({});
Default.args = {
  title: 'Popup title',
  onClose: () => ({}),
  children: <p>Popup content</p>,
};

export const WithButtons = Template.bind({});
WithButtons.args = {
  title: 'Popup title',
  onClose: () => ({}),
  buttons: [
    <LaunchAppButton key={'1'} onClick={() => ({})} />,
    <LaunchAppButton key={'2'} onClick={() => ({})} />,
  ],
  children: <p>Popup content</p>,
};
