import { ComponentStory } from '@storybook/react';

import { ProgressBar } from './progress-bar';

export default {
  title: 'Common/ProgressBar',
  component: ProgressBar,
};

const Template: ComponentStory<typeof ProgressBar> = (args) => <ProgressBar {...args} />;

export const Example = Template.bind({});
Example.args = {
  progressPercentage: 50,
  taskName: 'Downloading',
  onPaused: undefined,
  onResumed: undefined,
};

export const UndefinedPercentage = Template.bind({});
UndefinedPercentage.args = {
  taskName: 'Uninstalling',
};

export const WithButton = Template.bind({});
WithButton.args = {
  progressPercentage: 50,
  taskName: 'Downloading',
  onPaused: () => ({}),
  onResumed: () => ({}),
  isPaused: false,
};
