import { useEffect, useState } from 'react';
import { ComponentStory } from '@storybook/react';

import { DownloadChart } from './download-chart';

export default {
  title: 'DownloadChart',
  component: DownloadChart,
};

const Template: ComponentStory<typeof DownloadChart> = () => {
  const [data, setData] = useState<number[]>([0]);
  useEffect(() => {
    const interval = setInterval(() => {
      setData(d => [...d, Math.random() * 100]);
    }, 500);

    return () => clearInterval(interval);
  }, []);

  return <DownloadChart data={data} />;
};

export const Example = Template.bind({});
Example.args = {
  data: [200, 300, 250, 600, 450, 700],
};
