import { COLORS } from 'constant';

import { AppPathInput } from 'components/app-path-input';
import { Popup } from 'components/common/popup';
import { TaskButton } from 'components/common/task-button';

interface Props {
  onClose: () => void;
  onPathClick: () => void;
  installApp: () => void;
  path: string;
}

export const InstallPathPopup = ({ onClose, onPathClick, installApp, path }: Props) => {
  return (
    <Popup
      title="Choose install path"
      onClose={onClose}
      buttons={[
        <TaskButton
          onClick={onClose}
          key="cancel-button"
          text="Cancel"
          backgroundColor={COLORS.RED}
          hoverBackgroundColor={COLORS.HOVER_RED}
        />,
        <TaskButton
          onClick={installApp}
          key="install-button"
          text="Install"
          backgroundColor={COLORS.BLUE}
          hoverBackgroundColor={COLORS.HOVER_BLUE}
        />,
      ]}
    >
      <AppPathInput path={path} onClick={onPathClick} />
    </Popup>
  );
};
