import styled from 'styled-components';

import { LayoutStack } from 'components/common/layout-stack';

const Container = styled.div`
  width: 100%;
  height: 100%;
  overflow-y: scroll;
  padding-right: 1rem;
  margin-top: 2rem;
`;

interface Props {
  children: JSX.Element[] | JSX.Element;
}

export const LibraryGrid = ({ children }: Props) => (
  <Container>
    <LayoutStack rowElements={4} gapX={1} gapY={1.5}>
      {children}
    </LayoutStack>
  </Container>
);
