import { COLORS } from 'constant';
import styled from 'styled-components';

import { PlayIcon } from 'assets/icons';
import { Button } from 'components/common/button';

interface StyleProps {
  big?: boolean;
  backgroundImg?: string;
}

const Container = styled.div`
  border-radius: 0.25rem;
  display: flex;
  align-items: center;
  justify-content: center;
  width: ${(props: StyleProps) => (props.big ? '26rem' : '14.25rem')};
  height: ${(props: StyleProps) => (props.big ? '17.5rem' : '8rem')};
  background-image: ${(props: StyleProps) => `url(${props.backgroundImg})`};
  background-size: cover;
  background-position: center;
  background-color: ${COLORS.GRAT_TEXT};

  svg {
    width: 3.25rem;
    height: 3.25rem;
  }

  svg > path {
    fill: ${COLORS.WHITE};
  }
`;

interface Props extends StyleProps {
  onClick?: () => void;
  isVideo?: boolean;
}

export const MediaTile = ({ big, backgroundImg, onClick, isVideo }: Props) => (
  <Button onClick={onClick}>
    <Container big={big} backgroundImg={backgroundImg}>
      {isVideo && <PlayIcon />}
    </Container>
  </Button>
);
