import { useState } from 'react';
import { ComponentStory } from '@storybook/react';

import { ResumePauseButton } from './resume-pause-button';

export default {
  title: 'ResumePauseButton',
  component: ResumePauseButton,
};

const Template: ComponentStory<typeof ResumePauseButton> = (args) => {
  const [isPaused, setIsPaused] = useState(false);

  return (
    <ResumePauseButton
      {...args}
      isPaused={isPaused}
      onPause={() => setIsPaused(true)}
      onResume={() => setIsPaused(false)}
    />
  );
};

export const Example = Template.bind({});
Example.args = {
  isPaused: false,
};
