import styled from 'styled-components';

import { PauseIcon, PlayIcon } from 'assets/icons';
import { Button } from 'components/common/button';

interface StyleProps {
  width?: string;
  height?: string;
}

const StyledButton = styled(Button)<StyleProps>`
  svg {
    width: ${(props) => props.width || '2rem'};
    height: ${(props) => props.height || '2rem'};
  }
`;

interface Props extends StyleProps {
  isPaused?: boolean;
  onPause?: () => void;
  onResume?: () => void;
}

export const ResumePauseButton = ({ isPaused, onPause, onResume }: Props) => {
  return (
    <StyledButton onClick={isPaused ? onResume : onPause}>
      {isPaused ? <PlayIcon /> : <PauseIcon />}
    </StyledButton>
  );
};
