import { useState } from 'react';
import { ComponentStory } from '@storybook/react';

import { AllAppsIcon } from 'assets/icons';

import { SideBarButton } from './side-bar-button';

export default {
  title: 'SideBarButton',
  component: SideBarButton,
};

const Template: ComponentStory<typeof SideBarButton> = (args) => {
  const [isActive, setIsActive] = useState(false);

  return <SideBarButton {...args} onClick={() => setIsActive((v) => !v)} active={isActive} />;
};

export const Example = Template.bind({});
Example.args = {
  title: 'All Games',
  icon: <AllAppsIcon />,
};
