import styled from 'styled-components';

import { Button } from 'components/common/button';
import { ColorsValueType } from 'types/theme-types';

interface StyleProps {
  hoveredBackgroundColor: ColorsValueType;
}

interface Props extends StyleProps {
  icon: React.ReactNode;
  onClick: () => void;
}

const StyledButton = styled(Button)<StyleProps>`
  background-color: transparent;
  padding: 1rem;
  height: 3rem;
  width: 3rem;

  &:hover {
    background-color: ${(props) => props.hoveredBackgroundColor};
  }
`;

export const TitleBarIconButton = ({ icon, hoveredBackgroundColor, onClick }: Props) => (
  <StyledButton hoveredBackgroundColor={hoveredBackgroundColor} onClick={onClick}>
    {icon}
  </StyledButton>
);
