import { COLORS } from 'constant';
import { useCloseWindow, useMinimizeWindow } from 'patchkit-generic-patcher2_hooks';
import styled from 'styled-components';

import { ExitIcon, MinimizeIcon } from 'assets/icons';
import { HalfTransparentDiv } from 'components/common/half-transparent-div';
import { TitleBarIconButton } from 'components/title-bar-icon-button';

const Container = styled(HalfTransparentDiv)`
  display: flex;
  justify-content: space-between;
  align-items: center;
  width: 100%;
  -webkit-app-region: drag;
  height: 3rem;
`;

const ButtonsContainer = styled.div`
  display: flex;
  align-items: center;
  justify-content: flex-end;
  -webkit-app-region: none;
`;

export const TitleBar = () => {
  const exit = useCloseWindow();
  const minimize = useMinimizeWindow();

  return (
    <Container>
      <div>{/* TODO: add some icon */}</div>
      <ButtonsContainer>
        <TitleBarIconButton
          icon={<MinimizeIcon />}
          hoveredBackgroundColor={COLORS.LIGHT_GRAY}
          onClick={minimize}
        />
        <TitleBarIconButton
          icon={<ExitIcon />}
          hoveredBackgroundColor={COLORS.RED}
          onClick={exit}
        />
      </ButtonsContainer>
    </Container>
  );
};
