import { COLORS } from 'constant';
import styled from 'styled-components';

import { Popup } from 'components/common/popup';
import { TaskButton } from 'components/common/task-button';

interface Props {
  onClose: () => void;
  onAccept: () => void;
}

const Paragraph = styled.p`
  color: ${COLORS.WHITE};
  font-size: 1.25rem;
  font-weight: 700;
  text-align: center;
  margin: 0;
`;

export const UninstallConfirmationPopup = ({ onClose, onAccept }: Props) => {
  return (
    <Popup
      title=""
      onClose={onClose}
      buttons={[
        <TaskButton
          onClick={onClose}
          key="cancel-button"
          text="No"
          backgroundColor={COLORS.GRAY}
          hoverBackgroundColor={COLORS.GRAY_INPUT}
        />,
        <TaskButton
          onClick={onAccept}
          key="uninstall-button"
          text="Yes"
          backgroundColor={COLORS.BLUE}
          hoverBackgroundColor={COLORS.HOVER_BLUE}
        />,
      ]}
    >
      <Paragraph>Are you sure you want to uninstall this game?</Paragraph>
    </Popup>
  );
};
