import { COLORS } from 'constant';
import styled from 'styled-components';

import { Button } from 'components/common/button';

interface StyleProps {
  isActive?: boolean;
}

const Container = styled.div<StyleProps>`
  display: flex;
  justify-content: center;
  align-items: center;
  width: 3.5rem;
  height: 2.5rem;
  border-radius: 0.25rem;
  background-color: ${(props) => (props.isActive ? COLORS.WHITE : 'transparent')};
  color: ${(props) => (props.isActive ? COLORS.BLACK_TEXT : COLORS.WHITE)};
  font-size: 0.875rem;
  font-weight: 700;
  font-family: 'JetBrains Mono', monospace;

  &:hover {
    background-color: ${(props) => (props.isActive ? COLORS.HOVER_WHITE : COLORS.LIGHT_GRAY)};
  }
`;

interface Props extends StyleProps {
  onClick: () => void;
  text: string;
}

export const VersionLabelButton = ({ text, onClick, isActive }: Props) => (
  <Button onClick={onClick}>
    <Container isActive={isActive}>{text}</Container>
  </Button>
);
