import React, { createContext, useState } from 'react';

interface Context {
  backgroundImageUrl?: string;
  setBackgroundImageUrl: (imageUrl?: string) => void;
}

export const AppBackgroundContext = createContext<Context>({
  setBackgroundImageUrl: () => ({}),
});

export const AppBackgroundContextProvider = ({ children }: React.PropsWithChildren) => {
  const [backgroundImageUrl, setBackgroundImageUrl] = useState<string>();

  return (
    <AppBackgroundContext.Provider value={{ backgroundImageUrl, setBackgroundImageUrl }}>
      {children}
    </AppBackgroundContext.Provider>
  );
};
