import { useEffect, useState } from 'react';
import { AppPresentation } from 'patchkit-patcher2_foundation';
import { retrieveAppPresentationAsync } from 'patchkit-patcher2_ipc';

export const useAppPresentation = ({ appId }: { appId?: string }) => {
  const [appCurrentPresentation, setAppCurrentPresentation] = useState<
    AppPresentation | undefined
  >();

  useEffect(() => {
    (async () => {
      if (appId === undefined) {
        return;
      }

      if (appCurrentPresentation !== undefined) {
        return;
      }

      try {
        setAppCurrentPresentation(
          await retrieveAppPresentationAsync({
            appId,
          }),
        );
      } catch (e) {
        console.log('can\'t fetch launcher presentation', e);
      }
    })();
  }, [appId, appCurrentPresentation]);

  return appCurrentPresentation;
};
