import ReactDOM from 'react-dom/client';
import { BrowserRouter } from 'react-router-dom';
import {
  DownloadQueueContextProvider,
  LauncherStateContextProvider,
} from 'patchkit-generic-patcher2_hooks';

import { AppBackgroundContextProvider } from 'context/app-background-context';

import App from './App';
import reportWebVitals from './reportWebVitals';

import './index.css';

const root = ReactDOM.createRoot(document.getElementById('root') as HTMLElement);
root.render(
  // <React.StrictMode>
  <BrowserRouter>
    <LauncherStateContextProvider>
      <DownloadQueueContextProvider>
        <AppBackgroundContextProvider>
          <App />
        </AppBackgroundContextProvider>
      </DownloadQueueContextProvider>
    </LauncherStateContextProvider>
  </BrowserRouter>,
  // </React.StrictMode>,
);

// If you want to start measuring performance in your app, pass a function
// to log results (for example: reportWebVitals(console.log))
// or send to an analytics endpoint. Learn more: https://bit.ly/CRA-vitals
reportWebVitals();
